<?php
class TA_Line_Chart extends TA_Chart {
	private $_y_values = array();
	private $_colors = array();
	private $_resource_labels = array();
	
	/*
	 * Constructor, Order of function call should not be changed
	 */
	function __construct(){
		parent::__construct();			
		$this->set_x_labels();			
		$this->set_y_values();
		$this->set_colors();
		$this->set_resource_labels();		
	}
	
	
	/*
	 * Determining the Y-Axis Values
	 */
	function set_y_values(){
		foreach($this->_valid_resources as $row){
			$this->_y_values["$row[0]"]["$row[1]"]=$row[2];		
		}		

	}
	
	/*
	 * Setting the colour of resource to an array
	 */
	function set_colors(){
		foreach($this->_valid_resources as $row){
			$this->_colors["$row[1]"]=$this->get_color($row[3]);		
		}		
	}
	
	/*
	 * Determining the Resource Labels
	 */
	function set_resource_labels(){
		foreach($this->_valid_resources as $row){
			$this->_resource_labels["$row[1]"]=$row[1];		
		}		
	}
	
	/*
	 * Drawing the Line chart
	 */
	function draw() {
		$min_range=0;
		$max_range=0;
		$no_step=10;
		$step=0;
		$data = array();				
		
		foreach($this->_resource_labels as $r){
			
			$data = array();
			if(strlen($r)>17)
				$dot_title = "(".substr($r,0,17)."...".")";
			else 
				$dot_title = "(".$r.")";
										
			foreach($this->_x_labels as $x) {
					
				if(isset($this->_y_values["$x"]["$r"])){					
					$dot = new solid_dot((int)$this->_y_values["$x"]["$r"]);
					$dot->tooltip($this->_y_values["$x"]["$r"]."/". $this->_total[$x] .$dot_title);
					$data[]= $dot;
					
					//setting max_range
					if($max_range<(int)$this->_y_values["$x"]["$r"])
						$max_range = (int) $this->_y_values["$x"]["$r"];	
				}else{
					$dot = new solid_dot(0);
					$dot->tooltip("0"."/". $this->_total[$x]."$dot_title");
					$data[]=$dot;
				}		
			}			
			
			$line = new line();
			$line->set_values($data);
			
			$line->set_text($r);
			$line->set_colour($this->_colors[$r]);
			$this->_chart->add_element($line);					
		}
		
		$step = ( $max_range  -  $min_range ) / $no_step;
		
		foreach($this->_x_labels as $x){
			$lbl[] = $x;
		}
		
		$x_axis_labels = new x_axis_labels();
		$x_axis_labels->set_labels($lbl);
		$x_axis_labels->rotate(320);
		$x_axis = new x_axis();
		$x_axis->set_labels($x_axis_labels);
			
		$y_axis = new y_axis();
		$y_axis->set_range($min_range, $max_range,$step);

		$this->_chart->set_x_axis($x_axis);
		$this->_chart->set_y_axis($y_axis);
		$this->_chart->set_title($this->_title);
		echo $this->_chart->toString();
	}
}