<?php
class TA_Pie_Chart extends TA_Chart {
	
	/*
	 * Drawing the Pie Chart
	 */
	function __construct(){
		parent::__construct();	
	}
	
	function draw(){
		
		$tmp = array();
		$i=0;
		$pie_bounce = new pie_bounce(10);
		$total = 0;
		$display_total=0;
		
		foreach ($this->_rows as $row){
			$total += $row[2];
		}
		
		
		foreach($this->_valid_resources as $row){			
			if($total!=0)
				$perc = round(($row[2]/$total)*100);
			$pie_value = new pie_value((int)$row[2],$row[1]);
			$pie_value->set_colour($this->get_color($row[3]));
			$pie_value->add_animation($pie_bounce);
			$pie_value->set_tooltip("$row[2]/$total($perc%)");
			$tmp[] = $pie_value;
			$i++;
			$display_total += (int) $row[2];
		}
		
		$other_total = $total - $display_total;
		if($other_total>0){
			$perc = round(($other_total/$total)*100);
			$pie_value = new pie_value((int)$other_total,"Other");
			$pie_value->set_colour("#0000ff");
			$pie_value->add_animation($pie_bounce);
			$pie_value->set_tooltip("$other_total/$total($perc%)");
			$tmp[] = $pie_value;		
		}
				
		$this->_chart->set_title($this->_title);		
		$pie = new pie();
		$pie->set_values($tmp);
		$pie->radius(180);
		$this->_chart->add_element($pie);
		echo $this->_chart->toString();	
	}
}