<?php
/*

Plugin Name: Traffic Analyzer
Plugin URI: http://www.gladsys.in/wordpress-plugin-trafficanalyzer/
Description: Analyzes the traffic and trend of the site
Version: 1.1.2
Author: George Mathew K
Author URI: http://www.gladsys.in/author/george/ 
License: GPL2

*/

if(!class_exists("TrafficAnalyzer")){

class TrafficAnalyzer {
		
		const DEFAULT_NO_OF_TITLES = 3; 

		public function __construct() {
		
		}		

		public  function activate() {

			global $wp_version,$wpdb;
			
			if(version_compare($wp_version, "3.0","<"))
				die("Traffic Analyzer requires Wordpress Version 3.0 or greater");
			
			$sql = 	" create table if not exists $wpdb->prefix"."tanalyzer_visits ( ". 
					" 	id integer primary key auto_increment, ".
					" 	ip varchar(100) , ".
					" 	script_name varchar(2000), ".
					" 	user_agent varchar(2000), ".
					"	request_uri	varchar(2000), ".
					" 	remarks text, ".
					"	browser	varchar(1000),".
					"	resource_type	varchar(100),".
					"	resource	varchar(2000),".
					" 	vtime timestamp default now(),".
					"	http_referer text " .			
					" ) ";
			$wpdb->query($sql);		// wp_tanalyzer_visits
			
			
			

		}

		public function deactivate() {
			global $wpdb;
			$sql = " drop table if exists $wpdb->prefix"."tanalyzer_visits ";
			$wpdb->query($sql);
			
			
		}
		
		public function loaded() {
			$str="";
			global $wp_query;
			
			$resource_type = "";
			if($wp_query->is_home){
				$resource_type="HOME";
			}else if($wp_query->is_page) {
				$resource_type="PAGE";
			}else if($wp_query->is_single){
				$resource_type="POST";
			}else if($wp_query->is_comments_popup){
				$resource_type="COMMENTS_POPUP";
			}else if($wp_query->is_comment_feed){
				$resource_type="COMMENTS_FEED";
			}else if($wp_query->is_archive){
				$resource_type="ARCHIVE";
			}else if($wp_query->is_author){
				$resource_type="AUTHOR";
			}else if($wp_query->is_post_type_archive){
				$resource_type="POST_TYPE_ARCHIVE";
			}else if ($wp_query->is_robots){
				$resource_type="ROBOTS";
			}else if ( $wp_query->is_feed){
				$resource_type="FEED";
			}else if($wp_query->is_trackback){
				$resource_type="TRACKBACK";
			}else if($wp_query->is_404){
				$resource_type="404";
			}else if($wp_query->is_category){
				$resource_type="CATEGORY";
			}else if($wp_query->is_tag){
				$resource_type="TAG";
			}else if($wp_query->is_tax){
				$resource_type="TAX";
			}else if ( $wp_query->is_search){
				$resource_type="SEARCH";
			}else if($wp_query->is_admin){
				$resource_type="ADMIN";				
			}else {
				$resource_type="OTHER";
			}
			
			$browser="";
			
			if($GLOBALS["is_IE"]){
				$browser = "InternetExplorer";
			}else if($GLOBALS["is_gecko"]){
				$browser = "Firefox";
			}else if( $GLOBALS["is_chrome"]){
				$browser = "Chrome";
			}else if($GLOBALS["is_iphone"]){
				$browser = "IPhone";
			}else if ($GLOBALS["is_lynx"]){
				$browser = "Lynx";
			}else if($GLOBALS["is_macIE"]){
				$browser = "MAC IE";
			}else if ( $GLOBALS["is_NS4"]){
				$browser = "Netscape";
			}else if ( $GLOBALS["is_opera"]){
				$browser = "Opera";
			}else if( $GLOBALS["is_safari"]) {
				$browser = "Safari";
			}else if( $GLOBALS["is_winIE"]) {
				$browser = "Windows IE";
			}else {
				$browser = "Other";
			}

			$post = $wp_query->post;

			if(isset($post))
				$resource = $post->ID;
			else 
				$resource = "";
			
			$referer = wp_get_referer();
						
			global $wpdb;
			
			$sql = " insert into $wpdb->prefix"."tanalyzer_visits ( ip, script_name, user_agent, request_uri,resource_type,browser,resource,http_referer ) values ".
					" ('".$_SERVER["REMOTE_ADDR"]."', ".
					"'".$_SERVER['SCRIPT_NAME']."', " .
					" '".$_SERVER["HTTP_USER_AGENT"]."', ".
					" '". $_SERVER['REQUEST_URI']. "', ".
					" '".$resource_type."', " .
					" '".$browser."', " .
					" '".$resource ."', " .
					" '".$referer . "'" . 
					" )";
			
			if(in_array($resource_type, array("POST","PAGE")))
				$wpdb->query($sql);			
		}		
		
		public function add_style() {		
			$css_src = plugins_url("/css",__FILE__);			
			wp_enqueue_style('ta_handle1',$css_src."/ta_main.css",null,null);
		}		
		
		public function add_script() {
			$js_src = plugins_url("/js",__FILE__);			
			wp_enqueue_script('ta_handle2',$js_src."/ta_main.js.php","jquery",null);			
		}
		
		public function add_daterangepicker(){
			$css_src = plugins_url("/css",__FILE__);
			$js_src = plugins_url("/js",__FILE__);			
			$ofc_src = plugins_url("",__FILE__);
					
			wp_enqueue_style('ta_daterangepicker_css',$js_src."/daterangepicker/css"."/ui.daterangepicker.css");
			wp_enqueue_style('ta_jqueryui_css',$js_src."/daterangepicker/css/redmond"."/jquery-ui-1.7.1.custom.css");
					
			
			//wp_enqueue_script('jquery',$js_src."/daterangepicker/js"."/jquery-1.3.1.min.js");   // Uncomment this line to load jquery bundled with this plugin			
			wp_enqueue_script('jquery-ui',$js_src."/daterangepicker/js"."/jquery-ui-1.8.16.custom.min.js","jquery"); // Daterangepicker is not working with its bundled jquery-ui-1.7.1.custom.min.js
						
			$deps=array("jquery","jquery-ui");			
								
			wp_enqueue_script('ta_handle4',$js_src."/daterangepicker/js"."/daterangepicker.jQuery.js",$deps);
			wp_enqueue_script('ta_handle7',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ml.js",$deps);
			wp_enqueue_script('ta_handle8',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ar.js",$deps);
			wp_enqueue_script('ta_handle9',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-es.js",$deps);
			wp_enqueue_script('ta_handle10',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-fr.js",$deps);
			wp_enqueue_script('ta_handle11',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-ta.js",$deps);
			wp_enqueue_script('ta_handle12',$js_src."/daterangepicker/js"."/jquery.ui.datepicker-en-GB.js",$deps);		
			wp_enqueue_script('ta_handle13',$ofc_src."/ofc/js"."/swfobject.js",$deps);
			
					
			$qry_string = "period=".$_GET['period'];
			
			if(isset($_GET['daterangepicker']) && !empty($_GET['daterangepicker']))
				$qry_string .= "&daterangepicker=".$_GET['daterangepicker'];
			
			if(isset($_GET['daterangepicker_start']) && !empty($_GET['daterangepicker_start']))
				$qry_string .= "&daterangepicker_start=".$_GET['daterangepicker_start'];
			
			if(isset($_GET['daterangepicker_end']) && !empty($_GET['daterangepicker_end']))
				$qry_string .= "&daterangepicker_end=".$_GET['daterangepicker_end'];
				
			wp_enqueue_script('ta_handle14',$ofc_src."/ofc/js"."/loader.js.php?".$qry_string,$deps);
			
						
		}
		
		public function ta_settings(){
			global $current_user;		
						
			?>
			<div class="wrap">
			
			<?php screen_icon(); ?>
			
			<h2>Traffic Analyzer : Settings</h2>
			
			
			<?php 
					if(isset($_POST['ta_titles'])) {					
						global $current_user;
						$titles[$current_user->ID] = $_POST['ta_titles'];
						if(isset($current_user->ID)){
							update_option("ta_titles",$titles);
			?>
						<div class="updated settings-error" id="setting-error-settings_updated"> 
							<p><strong>Settings saved.</strong></p>
						</div>
			<?php 				
						}	
					}
			?>
						
			<h3>Titles to be displayed</h3>
					
			<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post">
			
				<table class="form-table">
				<tbody>
					<tr valign="top">
						<th scope="row">
							<label for="ta_titles">Titles to be displayed in the graph</label>
						</th>
						<td>
							<?php 
								$titles = get_option("ta_titles");
								global $current_user;
								$ta_title = $titles[$current_user->ID];
								if(!isset($ta_title) || empty($ta_title))
									$ta_title = self::DEFAULT_NO_OF_TITLES;							
							?>
							<select name="ta_titles" id="ta_titles">
								<option value="1" <?php echo ($ta_title==1)?"selected":"";  ?> >Top1</option>
								<option value="3" <?php echo ($ta_title==3)?"selected":"";  ?> >Top3</option>
								<option value="5" <?php echo ($ta_title==5)?"selected":"";  ?> >Top5</option>
								<option value="7" <?php echo ($ta_title==7)?"selected":"";  ?> >Top7</option>
								<option value="10" <?php echo ($ta_title==10)?"selected":"";  ?>  >Top10</option>								
								<option value="a" <?php echo ($ta_title=="a")?"selected":"";  ?> >All</option>
							</select>
						
						</td>
					</tr>
				</tbody>
				
				</table>
				<p class="submit"><input type="submit" value="Save Changes" class="button-primary" id="submit" name="submit">
				</p>
			</form>
			
			</div>
	
			<?php 
			
			
		}
	
		public function ta_report(){			
			$plugin_path = plugin_dir_path(__FILE__);	
			
			require_once $plugin_path . "/class-ta-data.php";			
			require_once $plugin_path . "/class-ta-data-graph.php";
			
			$table = new TA_Data_Graph();
					
			?>			
			<div class="wrap">			
			<?php screen_icon(); ?>			
			<h2>Traffic Analyzer : Visits</h2>			
			<form method="get" action="">
			<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
			<?php 
				$table->display();			
			?>
			</form>
			</div>			
			<?php 			
			}	// END OF ta_report
		}	// END OF CLASS	
	
	}	// END OF IF

	if(class_exists("TrafficAnalyzer")){
		$ta = new TrafficAnalyzer();
		
	}


	if(isset($ta)){
		if(!function_exists('ta_report')){
			function ta_report(){
				global $ta;
				if(function_exists("add_menu_page")) {
					$icon_url = plugin_dir_url(__FILE__)."images/analyzer.png";
					add_menu_page("Traffic Analyzer", "Analyzer", 9, "report_".basename(__FILE__),array(&$ta,'ta_report'),$icon_url);
					add_submenu_page("report_".basename(__FILE__), "Visits", "Visits", 0, "report_".basename(__FILE__),array(&$ta,'ta_report'));
					add_submenu_page("report_".basename(__FILE__), "Settings", "Settings", 0, "settings_".basename(__FILE__),array(&$ta,'ta_settings'));
				}					
			}		
		}
		
		add_action('admin_menu','ta_report');
		add_action('activate_trafficanalyzer/traffic-analyzer.php',array(&$ta,'activate'),1);
		
		add_action('shutdown',array(&$ta,'loaded'));		// Executed on index.php -> ./wp-blog-header.php -> wp() -> wp-includes/class-wp.php : main() : do_action_ref_array('wp', array(&$this));

		add_action('load-toplevel_page_report_traffic-analyzer',array(&$ta,"add_style"));
		add_action('load-analyzer_page_settings_traffic-analyzer',array(&$ta,"add_style"));
		add_action('load-toplevel_page_report_traffic-analyzer',array(&$ta,"add_daterangepicker"));
		add_action('load-toplevel_page_report_traffic-analyzer',array(&$ta,"add_script"));
		
		remove_action('wp_head', 'adjacent_posts_rel_link_wp_head');	// removes next and prev attribute of link tag. This is needed to prevent the prefetching mechanism of firefox by next attribute
			
	}
